package com.pragati;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URLEncoder;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.view.View;
import android.view.View.OnClickListener;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.widget.Button;
import android.widget.EditText;

public class MiloActivity extends Activity {

	private Button storeEndpointButton;
	private  EditText editText;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		this.editText = (EditText)this.findViewById(R.id.editText1);
		this.storeEndpointButton = (Button)this.findViewById(R.id.button1);

		// Step 1: Get your API Key
		final String apiKey = "d67e6ca8aae824cf09e3ea97112117f2";

		// Step 2: Prepare request data
		// Create search query using store_addresses endpoint
		// This query searches for stores within 5 miles of Palo Alto
		String query = null;
		try {
			query =  "key=" + URLEncoder.encode(apiKey, "utf-8") + "&postal_code=" + URLEncoder.encode("94301", "utf-8") + "&radius=" + URLEncoder.encode("5", "utf-8");
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// Create complete url
		final String url = "https://api.x.com/milo/v3/store_addresses?" + query;

		// Step 3: Hit store_address endpoint and get JSON response
		storeEndpointButton.setOnClickListener(new OnClickListener () {

			@Override
			public void onClick(View arg0) {
				// call the network call in the background
				new MyAsyncTask().execute(url);	
			}});			
	}		



	private class MyAsyncTask extends AsyncTask<String, Void, Void>
	{
		String jsonStr;

		@Override
		protected void onPostExecute(Void result) {

			// Step 4: Parse JSON response and display result
			int num;
			try {
				JSONObject jsonObj = new JSONObject(jsonStr);

				// using JSONArray to grab the stores from store_addresses
				JSONArray storesArr = jsonObj.getJSONArray("store_addresses");  

				// lets loop through the JSONArray and get all the items 
				num = storesArr.length();
				editText.setText(num + " stores showed up!");
				for (int i = 0; i < num; i++) { 
					// printing the values to the logcat 
					System.out.println(storesArr.getJSONObject(i).getString("merchant_name").toString()); 
					System.out.println(storesArr.getJSONObject(i).getString("city").toString()); 			    
				} 

			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} 			
		}

		@Override
		protected void onPreExecute() {
		}

		@Override
		protected Void doInBackground(String... params) {

			// Get the data from the store_addresses endpoint
			System.out.println("This is the URL in asynctask === " + params[0]);
			BufferedReader in = null;
			try {
				HttpClient client = new DefaultHttpClient();
				HttpGet request = new HttpGet();
				request.setURI(new URI(params[0]));
				HttpResponse response = client.execute(request);
				in = new BufferedReader
				(new InputStreamReader(response.getEntity().getContent()));
				StringBuffer sb = new StringBuffer("");
				String line = "";
				String NL = System.getProperty("line.separator");
				while ((line = in.readLine()) != null) {
					sb.append(line + NL);
				}
				in.close();
				jsonStr = sb.toString();
				System.out.println(jsonStr);
			} catch (URISyntaxException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (ClientProtocolException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} finally {
				if (in != null) {
					try {
						in.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
			return null;
		}
	}
}