//
//  MiloTestViewController.m
//  MiloTest
//
//  Created by Rai, Pragati on 7/17/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import "MiloTestViewController.h"
#import "JSONKit.h"

@implementation MiloTestViewController

@synthesize label;
@synthesize storeAddresses;
@synthesize responseData;

- (IBAction) storeAddressesClicked: (id)sender {
	
	//Step 1: Get your API KEY 
	NSString *api_key = @"d67e6ca8aae824cf09e3ea97112117f2";
	
	// Step 2: Prepeare request data
	//Create search query using store_addresses endpoint
	NSString *searchQuery = [NSString stringWithFormat:@"key=%@", api_key];
	
	NSString *encodedSearchQuery = [searchQuery stringByAddingPercentEscapesUsingEncoding:NSASCIIStringEncoding];
	
	// Create store_addresses endpoint URL
	NSString *storeAddressesUrlString = [NSString stringWithFormat: @"https://api.x.com/milo/v3/store_addresses?%@", encodedSearchQuery];
	
	NSLog(@"url string = %@", storeAddressesUrlString);
	// Step 3: Open URL and get response
	self.responseData = [NSMutableData data];
	
    NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:storeAddressesUrlString]];
    [[NSURLConnection alloc] initWithRequest:request delegate:self];
  
}

	
- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
    [connection release];
	
	//Step 4: Parse the result data
    NSString *responseString = [[NSString alloc] initWithData:responseData encoding:NSUTF8StringEncoding];
	
	NSLog(@"response string = %@", responseString);
	self.responseData = nil;
	
	NSDictionary *deserializedData = [responseString objectFromJSONString];
	
	NSArray* stores = [deserializedData objectForKey:@"store_addresses"];
	[responseString release];
	
	//get first merchant
	NSDictionary* firstStore = [stores objectAtIndex:0];
	
	//fetch the data
	NSString * merchantName = [firstStore objectForKey:@"merchant_name"];
	NSString * city = [firstStore objectForKey:@"city"];
	NSString * region = [firstStore objectForKey:@"region"];
	
	
	//set the text to the label
	label.text = [NSString stringWithFormat:@"Merchant Name: %@ \n City: %@  %@",
				  merchantName, city, region
				  ];
	
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response {
    [responseData setLength:0];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
    [responseData appendData:data];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
	[connection release];
	self.responseData = nil;
}



/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
